/* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day
 *
 * Author:     Walter Huang
 * Student ID: 9820137
 * Section:    BB
 *	
 * STARTER PROGRAM
 *
 * To start with, your job is to figure out how this program works.
 *
 * Greeting Card Designer (Ultimate version)
 *
 *  The GP142 graphics window shows some buttons and the inside
 *  or outside (cover) of a greeting card.  The idea is that you 
 *  can design what you want to card to look like by adding and moving
 *  objects: 
 *    messages, message color and position
 *    shapes,   shape color and position
 *
 *   To place a message or a greeting, you click on an appropriate button, and 
 *   then you can click on the desired position in the card.  
 
 *	 In this starter version, you can do much less.
 *   You can change the card background, place one shape on the card,
 *   and change the shape back and forth between two possible kinds.
 */

#include "gp142.h"
#include <math.h>
#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE    		1
#define FALSE   		0

/*
 * The state, or status you are in determines what happens when you click 
 * the card:
 * ADD SHAPE   -- you click the card, and a new object is placed there.
 *                You get into this mode by clicking an ADD button.
 *                After doing an ADD, you are put into SELECTED mode.
 * SELECTED    -- An object is selected. In this mode, the type 
 *                rotation applies to thecurrent object.
 */
/* Hint: you may need to add statuses when you make the program more complex.*/
#define STATUS_ADD_SHAPE 1
#define STATUS_SELECTED 2
#define STATUS_ADD_MESSAGE 3
#define STATUS_SELECT_OBJECT 4
#define STATUS_OBJECT_SELECTED 5
#define STATUS_KEEP_SHAPE 6
#define STATUS_KEEP_MESSAGE 7
#define STATUS_FIRE_BALL 8
#define STATUS_DRAGON_SLAVE 9
/* Configure the appearance of the buttons on the menu bar 
 * by setting the number of pixels of button height and width
 */
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	9
#define SELECTED_COLOR  RED

/* Position of the card in the window */
#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH +60)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0
#define NOFILL 1

/* Types of objects we support.  (Perhaps not all types are used yet.)*/
#define OBJECT_NONE 0
#define OBJECT_SHAPE 1
#define OBJECT_MESSAGE 2

/*if you add new types, you may need to change this*/
#define MAX_SHAPES	4
#define MAX_MESSAGE 5
/* These are the kinds of shapes we support.  You'll need to add more. */
#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_FLASH 2
#define SHAPE_FLOWER 3
/* There are the kinds of messages */
#define MESSAGE1	0
#define MESSAGE2	1
#define MESSAGE3	2
#define MESSAGE4	3
#define MESSAGE5	4

#define ARRAY_SIZE 500

/*Possible places for mouse clicks*/
#define CLICK_BUTTON 1  /* You clicked on SOME button (doesn't say which one)*/
#define CLICK_CARD 2    /* You clicked in the card area */
#define CLICK_OUTSIDE 3	/* You clicked outside the card area, not on a button*/	
#define CLICK_OBJECT 4  /* You clicked on the center of object */	

#define HEART_WIDTH 35
#define STARPOINTS 5
#define STARRADIUS 40
#define PI 3.1416
/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions */
void DrawBlankScreen (void);
void DrawButtons(int last_button);
void DrawCard (int background_color, int status, int status2, int object_count, 
			   int object_num[], int object_type[],int object_color[], 
			   int object_x[], int object_y[], int *Fire_Ball_x, int *Fire_Ball_y,
			   int n, int c);
void DrawHeart (int x, int y, int color);
void DrawSmallHeart (int x, int y, int color);
void DrawStar (int x, int y, int color);
void DrawFlash (int x, int y, int color);
void DrawFlower (int x, int y, int color);
void DrawObjects(int object_num, int object_type, int color, 
				 int bottom_x, int bottom_y, int background_color, int c);
/* Mouse click handling functions */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int object_type[], 
					  int object_num[], int object_color[], int object_x[], 
					  int object_y[], int *last_button, int *object_count2,
					  int *status2, int *quit, int *Fire_Ball_x, int *Fire_Ball_y);

int  ClassifyMouseClick(int mouse_x, int mouse_y, int *status, int object_count, 
						int *n,	int object_x[], int object_y[]);

void HandleButton(int x, int y, int *background_color, int *status,
				  int *object_count, int object_type[], int object_num[],
				  int *last_button, int *object_count2, int *status2,
				  int object_color[], int *quit, int *Fire_Ball_x, int *Fire_Ball_y);

/* Add a shape to the card. */
void AddShape(int x, int y, int *status, int *object_count2, 
			   int object_type[], int object_num[], int object_color[], 
			   int object_x[], int object_y[], int *status2);

void AddMessage(int x, int y, int *status, int *object_count2, 
			   int object_type[], int object_num[], int object_color[], 
			   int object_x[], int object_y[], int *status2);

void AddMessage1 (int x, int y, int color);
void AddMessage2 (int x, int y, int color);
void AddMessage3 (int x, int y, int color);
void AddMessage4 (int x, int y, int color);
void AddMessage5 (int x, int y, int color, int background_color, int c);

void DrawFireBall (int x, int y);
void DragonSlave (int n);
void ReDrawScreen (int color);
void PrintTitle(int r);
/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{
	int quit = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	char key_hit;                  /* which key was hit            */
	
	
	/*variables and their default values*/
	int background_color = YELLOW;
	int status = STATUS_ADD_SHAPE;
	int status2 = STATUS_ADD_SHAPE;
	
	/* Each object will have a number telling what kind of object it is, a color,
	 * and an x and y coordinate.  You'll need to make these into arrays so you
	 * can support more than one object.
	 */
	int object_count = 0;	      /* How many objects on the page? */
	int object_count2 = 0;		  /* A second counter for the objects */
	
	int object_type[ARRAY_SIZE];  /* Object is either a shape or message */
	int object_num[ARRAY_SIZE];   /* Type of object */
	int object_color[ARRAY_SIZE]; /* Color of object */
	
	int object_x[ARRAY_SIZE];     /* Position of object */
	int object_y[ARRAY_SIZE];
	
	int last_button = -1;           /* Keep track of the last button clicked.
	                                   This would be usefull when highlighting
	                                   the last button the user clicked */

	int event; /*the most recent GP142 event*/
	int Fire_Ball_x;	/* Position of the fire ball */
	int Fire_Ball_y;
	
	int n = 0, j = 0, r = 0, c = 0; /* counters */
	
		
	time_t t; /*needed only when initializing a random number generator*/
	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	    /* Seed the random number generator. This is 
							   something you should do if you plan to use 
							   random numbers. Leave it here in your program 
							   and forget about it.*/
	

	/* These GP142 initializations don't need to be changed */
	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */
	
	
	
	/*
	 * The main event loop:
	 * --- ---- ----- -----
	 * wait for the next user action, such as a mouse click or keyboard
	 * keypress, or a periodic update event (allowing us to display the
	 * next frame of an animation -- not used directly in this program)
	 * and call the appropriate function to handle it.  Repeat this until 
	 * the user signals "quit".
	 */
	while (!quit) {  /*this is the famous "event loop" */
		
		/*start by redrawing everything */
		DrawBlankScreen ();
		DrawButtons(last_button);	  /* Show the buttons...*/ 
		PrintTitle(r);
		DrawCard (background_color, status, status2, object_count, object_num,
			object_type, object_color, object_x, object_y, &Fire_Ball_x,
			&Fire_Ball_y, n, c);
		
		/*Wait for something to happen */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
			
		/* Something just happened.  Figure out what it was, and react 
		   appropriately. */
		switch (event) {
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop */
			break;
			
		case GP142_KBD:  /*A key was pressed */
			/*not needed for this program. Use this if user will need to 
			  hit a key. Note that scanf CANNOT be used with GP142.  If you 
			  use this, the key character value is in variable "key_hit"*/
			break;
			
		case GP142_MOUSE:
			/* A mouse click has occurred. Call the mouse handler to 
			   decide where the click was and react as needed. */
			HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 
							 &object_count, object_type, object_num, 
							 object_color, object_x, object_y, &last_button,
							 &object_count2, &status2, &quit, &Fire_Ball_x,
							 &Fire_Ball_y);			
			break;
			
		case GP142_PERIODIC:
			/* Moving the fire ball from its original position to where the object
				is */
			if(status == STATUS_FIRE_BALL)
			{
				if(Fire_Ball_x <= object_x[object_count2] - 5)
				{
					Fire_Ball_x += 10;
				}
				
				if(Fire_Ball_y <= object_y[object_count2] - 5)
				{
					Fire_Ball_y += 10;
				}

				if(Fire_Ball_x > object_x[object_count2] - 5&& 
					Fire_Ball_y > object_y[object_count2] - 5)
				{
					object_type[object_count2] = OBJECT_NONE;
					status = STATUS_ADD_SHAPE;
				}

			}
			
			/* Flash incantation lines of Dragon Slave */
			if (status != STATUS_DRAGON_SLAVE)
				n = 0;
			if (status == STATUS_DRAGON_SLAVE)
			{
				if (n > 80)
				{
					status = STATUS_ADD_SHAPE;
					for (j = 0; j < ARRAY_SIZE; j++)
						object_type[j] = OBJECT_NONE;
					object_count = 0;
					object_count2 = 0;
					n = 0;
				}
				n = n + 1;
			}
			
			/* Time counter for the title */
			r = r + 1;
			if (r > 300)
				r = 0;
			/* Time counter for the blinking */
			c = c + 1;
			/* End of periodic event updates */								
		default:
			break;
			
		}  /*end switch */
	}  /* end event loop */
	
	
	/*
	 * WRAP-UP
	 */
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/
/* 
 * For a blank screen just draw a white rectangle that covers the whole
 * GP142 window.
 */
void DrawBlankScreen (void) 
{
	GP142_rectangleXY (WHITE, -GP142_XMAX, -GP142_YMAX, GP142_XMAX, GP142_YMAX,
					FILL);
} /*end DrawBlankScreen */

void ReDrawScreen (int color)
{
	GP142_rectangleXY (color, -GP142_XMAX, -GP142_YMAX, GP142_XMAX, GP142_YMAX,	
					FILL);
}

/* Draws the buttons */
void DrawButtons(int last_button)
{
	char b_labels [NUM_BUTTONS][25] = 
	{
		"Background Color",
		"Next, Please",
		"Add Shape",
		"Add Message",
		"Select Object",
		"Object Color",
		"Fire Ball",
		"Dragon Slave",
		"Quit Program"
	};
	
	int i, text_offset = -GP142_XMAX + 6, font_size = 12;
	int y, label_y;
	
	/* draw rectangles and labels for each button */
	for(i = 0; i < NUM_BUTTONS; i++) 
	{
		y = GP142_YMAX - i * BUTTON_HEIGHT;
		
		GP142_rectangleXY(GREEN,
			-GP142_XMAX + 4,
			y - 2,
			-GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 2, FILL);

		GP142_rectangleXY(BLACK,
			-GP142_XMAX + 4,
			y - 2,
			-GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 2, NOFILL);
		
		
		label_y = y - BUTTON_HEIGHT/2;
		/* Change the color of the test on the label which was the last
			button that user clicked on */
		if (i == last_button)
			GP142_printfXY(SELECTED_COLOR, text_offset, label_y, font_size, 
							b_labels[i]);	
		else
			GP142_printfXY(BLACK, text_offset, label_y, font_size, b_labels[i]);	
	}	
}

/* Prints title messages which flash a different message every second or so */
void PrintTitle (int r)
{
	if (r >= 0 && r < 20)
		GP142_printfXY (RED, PAGE_LLX, GP142_YMAX-40, 14,
			"IT IS THAT TIME OF THE YEAR AGAIN!");
	if (r >= 20 && r < 40)
		GP142_printfXY (BLUE, PAGE_LLX, GP142_YMAX-40, 14,
			"UMMM...WHAT SHOULD I GIVE MY SWEETHEART THIS YEAR?");
	if (r >= 40 && r < 60)
		GP142_printfXY (RED, PAGE_LLX, GP142_YMAX-40, 14,
			"LET'S SEE...FLOWERS?");
	if (r >= 60 && r < 80)
		GP142_printfXY (BLUE, PAGE_LLX, GP142_YMAX-40, 14,
			"NAH...TOO COMMON.");
	if (r >= 80 && r < 100)
		GP142_printfXY (RED, PAGE_LLX, GP142_YMAX-40, 14,
			"A NICE BOX OF CHOCOLATES?");
	if (r >= 100 && r < 120)
		GP142_printfXY (BLUE, PAGE_LLX, GP142_YMAX-40, 14,
			"NAH...SHE'S ON DIET.");
	if (r >= 120 && r < 150)
		GP142_printfXY (RED, PAGE_LLX, GP142_YMAX-40, 14,
			"AHH...I KNOW, WHY DON'T I USE SOMETHING I LEARNED IN CSE.");
	if (r >= 150 && r < 180)
		GP142_printfXY (BLUE, PAGE_LLX, GP142_YMAX-40, 14,
			"DECLARE VARIABLES HERE, WRITE A FUNCTION THERE......");
	if (r >= 180 && r < 200)
		GP142_printfXY (RED, PAGE_LLX, GP142_YMAX-40, 14,
			"48 HOURS ELAPSED......");
	if (r >= 200 && r < 220)
		GP142_printfXY (BLUE, PAGE_LLX, GP142_YMAX-40, 14,
			"YES!!!  IT COMPILES, IT COMPILES!!!.");
	if (r >= 220 && r < 300)
		GP142_printfXY (RED, PAGE_LLX, GP142_YMAX-40, 14,
			"DESIGN YOUR OWN VALENTINE'S CARD PROGRAM - VERSION 4U.");
}


/* Render (draw) the page and all its contents. */
void DrawCard (int background_color, int status, int status2, int object_count, 
			   int object_num[], int object_type[],int object_color[], 
			   int object_x[], int object_y[], int *Fire_Ball_x, int *Fire_Ball_y,
			   int n, int c)
{
	int font_size = 14, i;
	
	/* Draw the background of the card. */
	GP142_rectangleXY (background_color,
		PAGE_LLX, PAGE_LLY,
		PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT,
		FILL);
	
	/* Draw all existing objects on the card. */
	for(i = 0; i <= object_count; i++)
		DrawObjects (object_num[i], object_type[i], object_color[i], object_x[i], 
			object_y[i], background_color, c);
	
	/* Draw fire ball when the user wish to delete an object */
	if (status == STATUS_FIRE_BALL)
		DrawFireBall (*Fire_Ball_x, *Fire_Ball_y);
	/* Call DragonSlave funtion when user wants to start over */
	if (status == STATUS_DRAGON_SLAVE)
		DragonSlave (n);
	
	/* Write an appropriate status message below the background */
	switch (status) {
	case STATUS_ADD_SHAPE:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
			"Click on the card to add a shape.");
		break;
	case STATUS_SELECTED:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size-3,
		"Object selected. Click button to modify, or click on the card to move the object.");
		break;
	case STATUS_ADD_MESSAGE:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size-3,
			"Click on the card to add a message.");
		break;
	case STATUS_SELECT_OBJECT:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size-3,
			"Click on the center of the object to select the object.");
		break;
	case STATUS_OBJECT_SELECTED:
		GP142_printfXY (BLUE, PAGE_LLX, PAGE_LLY-40, font_size-3,
		"Object selected. Click button to modify, or click on the card to move the object.");
		break;
	case STATUS_FIRE_BALL:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size-1,
			"Fire Ball Casted, the selected object will be destroyed.");
		break;
	case STATUS_DRAGON_SLAVE:
		GP142_printfXY (MAGENTA, PAGE_LLX, PAGE_LLY-40, font_size-2,
			"Starting Over, click on the card to cancel before it's too late.");
		break;
	default:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
			"Status error -- notify programmer");
		break;
	} /*end switch */
} /*end DrawPage */


/* Draw one existing object. */
void DrawObjects(int object_num, int object_type, int color, 
				 int bottom_x, int bottom_y, int background_color, int c) 
{
	if (object_type == OBJECT_SHAPE)
	{
		switch (object_num) 
		{
			case SHAPE_HEART:
				DrawHeart (bottom_x, bottom_y, color);
				break;
			case SHAPE_STAR:
				DrawStar (bottom_x, bottom_y, color);
				break;
			case SHAPE_FLASH:
				DrawFlash (bottom_x, bottom_y, color);
				break;
			case SHAPE_FLOWER:
				DrawFlower (bottom_x, bottom_y, color);
			default:
				/* Unknown shape selected */
				break;
		} /*end switch*/
	}
	
	if (object_type == OBJECT_MESSAGE)
	{
		switch (object_num) 
		{
			case MESSAGE1:
				AddMessage1 (bottom_x, bottom_y, color);
				break;
			case MESSAGE2:
				AddMessage2 (bottom_x, bottom_y, color);
				break;
			case MESSAGE3:
				AddMessage3 (bottom_x, bottom_y, color);
				break;
			case MESSAGE4:
				AddMessage4 (bottom_x, bottom_y, color);
				break;
			case MESSAGE5:
				AddMessage5 (bottom_x, bottom_y, color, background_color, c);
				break;
			default:
				/* Unknown message selected */
				break;
		}
	}
}

/* Draw a heart on the card. A heart will be made by two overlapping
	 circles and a triangle.
   The pulsation is caused by adding a small, random amount to the 
   heart height each time this function is called. */

void DrawHeart (int x, int y, int color) 
{
	int h = (HEART_WIDTH/2) + (rand () %4);

	GP142_circleXY (color, x - h + 5, y, h);
	GP142_circleXY (color, x + h - 5, y, h);
	GP142_triangleXY (color, x- h*2 +5, y-5,
						x + h*2 -5, y-5,
						x, y - h*2 -5, FILL);
}

/* Draw a smaller heart */
void DrawSmallHeart (int x, int y, int color) 
{
	int h = (HEART_WIDTH/4) + (rand () %4);

	GP142_circleXY (color, x - h + 2, y, h);
	GP142_circleXY (color, x + h - 2, y, h);
	GP142_triangleXY (color, x- h*2 +2, y-2,
						x + h*2 -2, y-2,
						x, y - h*2 -2, FILL);
}


/*
 * Draw a star on the card.
 *
 * We make the star twinkle by selecting the number of points randomly.  Each 
 * time it is redrawn, it is slightly different than the time before, which 
 * makes it appear to pulsate,
 */

void DrawStar (int x, int y, int color) 
{
	int sp;
	double angle;
	int x1, y1;

	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);
	}
}


void DrawFlash (int x, int y, int color)
{
	int h = 3 + (rand () %3);

	GP142_rectangleXY(color, x - h, y - h, x + h, y + h, FILL);

	GP142_triangleXY (color, x - h, y - h, x - h, y + h,
						x - 20 - h, y, FILL);
	GP142_triangleXY (color, x - h, y + h, x + h, y + h,
						x, y + 20 + h, FILL);
	GP142_triangleXY (color, x + h, y + h, x + h, y - h,
						x + 20 + h, y, FILL);
	GP142_triangleXY (color, x + h, y - h, x - h, y - h,
						x, y - 20 - h, FILL);
}

void DrawFlower (int x, int y, int color)
{
	int sp;
	double angle;
	int x1, y1;
	
	GP142_circleXY (color, x, y, 20);
	sp = STARPOINTS + (rand () %2);
	
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) 
	{
		x1 = (int) (cos (angle) * (STARRADIUS - 5));
		y1 = (int) (sin (angle) * (STARRADIUS - 5));
		GP142_circleXY (color, x+x1, y+y1, 12);
		GP142_circleXY (color, x-x1, y-y1, 12);
	}
}


void DrawFireBall (int x, int y)
{
	int r;
	DrawStar(x, y, BLUE);
	r = rand() % 5;
	GP142_circleXY (RED, x, y, 20 + r);
	GP142_circleXY (ORANGE, x, y, 7 + r);
	GP142_circleXY (YELLOW, x, y, 5);
}


void DragonSlave (int n)
{
	/*
	Darkness from twilight, crimson from
	blood that flows... Buried in the flow of
	time... in thy great name, I pledge myself to
	darkness! Those who oppose us shall be
	destroyed by the power you and I possess!
	DRAGON SLAVE!! */

	/* NOTE: This part is a incantation of a magic from a Japanese Animation.
		It is not some dark, crazy stuff that you might think.  I just put it 
		in there for fun.  The purpose of this is to delete all the objects, 
		reset the counters and start all over without exiting the program */

	if (n >= 0 && n < 10)
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-60, 14,
			"Darkness from twilight,");
	if (n >= 10 && n < 20)
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-60, 14,
			"Crimson from blood that flows....");
	if (n >= 20 && n < 30)
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-60, 14,
			"Buried in the flow of time...");
	if (n >= 30 && n < 40)
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-60, 14,
			"In thy great name, I pledge myself to darkness!");
	if (n >= 40 && n < 50)
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-60, 14,
			"Those who oppose us shall be destroyed by the power you and I possess!");
	if (n >= 50 && n < 60)
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-60, 16,
			"DRAGON SLAVE!!");
	if (n >=60 && n < 65)
		ReDrawScreen (YELLOW);
	if (n >=65 && n < 70)
		ReDrawScreen (ORANGE);
	if (n >=70 && n < 75)
		ReDrawScreen (RED);
	if (n >=75 && n < 80)
		ReDrawScreen (BLACK);
	/* Again!  I am NOT crazy or in some stupid evil cult. */
}

	
void AddMessage1 (int x, int y, int color)
{
	int font;
	font = 12 + (rand() % 3);
	
	GP142_printfXY(color, x, y, font, "TO MY LUV!!!");
}

void AddMessage2 (int x, int y, int color)
{
	int font;
	font = 12 + (rand() % 3);
	GP142_printfXY(color, x, y, font, "PLEASE BE MY VALENTINE");
}

void AddMessage3 (int x, int y, int color)
{
	int font;
	font = 12 + (rand() % 3);
	GP142_printfXY(color, x, y, font, "LOVE U 4EVER");
}

void AddMessage4 (int x, int y, int color)
{
	int font;
	font = 12 + (rand() % 3);
	GP142_printfXY(color, x, y, font, "I");
	DrawSmallHeart (x + 35, y + 10, color);
	GP142_printfXY(color, x + 70, y, font, "YOU!!!");
}

/* Blinking text effect */
void AddMessage5 (int x, int y, int color, int background_color, int c)
{	
	if (c % 2 == 0)
		GP142_printfXY(color, x, y, 12, "From:  Your Secret Admirer.");
	if (c % 2 == 1)
		GP142_printfXY(background_color, x, y, 12, "From:  Your Secret Admirer.");
}
	
/* Mouse clicks occur in one of three regions of interest: on buttons, 
   on the card, or anywhere else. */
int  ClassifyMouseClick(int mouse_x, int mouse_y, int *status, int object_count, 
						int *n,	int object_x[], int object_y[])
{
	int i;
	if(*status != STATUS_SELECT_OBJECT)
	{
		if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) && 
			(mouse_y < GP142_YMAX) &&
			(mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
			return CLICK_BUTTON;
		else
		{
			if (mouse_x >= PAGE_LLX && 
				mouse_x < PAGE_LLX + PAGE_WIDTH && 
				mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
				return CLICK_CARD;
			else
				return CLICK_OUTSIDE;
		}
	}

	if(*status == STATUS_SELECT_OBJECT)
	{
		if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) && 
			(mouse_y < GP142_YMAX) &&
			(mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
			return CLICK_BUTTON;
		else
		{
			for(i=0; i <= object_count; i++)
			{
				if ((mouse_x >= object_x[i] - 10) &&
					(mouse_y >= object_y[i] - 10) &&
					(mouse_x <= object_x[i] + 10) &&
					(mouse_y <= object_y[i] + 10))
				{
					*n = i;
					*status = STATUS_OBJECT_SELECTED;
					return CLICK_OBJECT;
				}
			}
			return CLICK_OUTSIDE;
		}
	}
	else
		return CLICK_OUTSIDE;
}


/* Decide where a mouse click occured, and react appropriately. */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int object_type[], 
					  int object_num[], int object_color[], int object_x[], 
					  int object_y[], int *last_button, int *object_count2,
					  int *status2, int *quit, int *Fire_Ball_x, int *Fire_Ball_y)
{

	int mouse_click, n=0;
	mouse_click = ClassifyMouseClick(mouse_x, mouse_y, status, *object_count, &n,
									 object_x, object_y);
			
	if (mouse_click == CLICK_BUTTON) 
	{			
		/* A button has been clicked.  Call a function to handle it*/
		/* most of the variables passed as args will NOT change*/
		HandleButton(mouse_x, mouse_y, background_color, status, 
					 object_count, object_type, object_num, last_button, 
					 object_count2, status2, object_color, quit,
					 Fire_Ball_x, Fire_Ball_y);
	} 
	
	if (mouse_click == CLICK_OBJECT)
	{
		*object_count2 = n;
		if(object_type[n] == OBJECT_SHAPE)
			*status2 = STATUS_KEEP_SHAPE;
		else
			*status2 = STATUS_KEEP_MESSAGE;
	}

	if (mouse_click == CLICK_CARD) 
		/* Add an object, or this also moves the currently selected object
			around on the card*/
	{
			if (*status2 == STATUS_ADD_SHAPE || *status2 == STATUS_KEEP_SHAPE)
				AddShape(mouse_x, mouse_y, status, object_count2, 
					object_type, object_num, object_color, object_x,
					object_y, status2);
			if (*status2 == STATUS_ADD_MESSAGE || *status2 == STATUS_KEEP_MESSAGE)
				AddMessage(mouse_x, mouse_y, status, object_count2, 
					object_type, object_num, object_color, object_x,
					object_y, status2);
	}
	/* Ignore any other mouse clicks */
}

/* Figure out which button was clicked, if any, and do the right thing. */
void HandleButton(int x, int y, int *background_color, int *status,
				  int *object_count, int object_type[], int object_num[],
				  int *last_button, int *object_count2, int *status2,
				  int object_color[], int *quit, int *Fire_Ball_x, int *Fire_Ball_y)
{
	int buttonNum = 0;
	
	/* If we're outside of this area, we could not have clicked on
	   a button. */
	if (x > -GP142_XMAX + BUTTON_WIDTH)  
		return ;	/*That's an error situation*/
	
					/* We know the mouse clicked in the column of buttons. Calculate
					* which one.
	*/
	buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* Change the background color */
		*background_color = (*background_color + 1) % MAX_COLORS;
		*last_button = 0;
		break;
	case 1:
		/* Change the type of the currently selected object */
		if (object_type[*object_count2] == OBJECT_SHAPE)
			object_num[*object_count2] = (object_num[*object_count2] + 1) % MAX_SHAPES;
		if (object_type[*object_count2] == OBJECT_MESSAGE)
			object_num[*object_count2] = (object_num[*object_count2] + 1) % MAX_MESSAGE;
		*last_button = 1;
		break;
	case 2:
		/* Add a Shape */
		*status = STATUS_ADD_SHAPE;
		*object_count = *object_count + 1;
		*object_count2 = *object_count;
		*status2 = STATUS_ADD_SHAPE;
		*last_button = 2;
		break;
	case 3:
		/* Add a Message */
		*status = STATUS_ADD_MESSAGE;
		*object_count = *object_count + 1;
		*object_count2 = *object_count;
		*status2 = STATUS_ADD_MESSAGE;
		*last_button = 3;
		break;
	case 4:
		/* Select an Object*/
		*status = STATUS_SELECT_OBJECT;
		*last_button = 4;
		break;
	case 5:
		/* Change the color of selected object */
		object_color[*object_count2] = (object_color[*object_count2] + 1) % MAX_COLORS;
		*last_button = 5;
		break;
	case 6:
		/* Cast a fire ball to delect the selected object */
		*Fire_Ball_x = -GP142_XMAX + 100;
		*Fire_Ball_y = -GP142_YMAX + 100;
		*status = STATUS_FIRE_BALL;
		*last_button = 6;
		break;
	case 7:
		/* Erase everything and start over */
		*status = STATUS_DRAGON_SLAVE;
		*last_button = 7;
		break;
	case 8:
		/* Quit Program */
		*quit = TRUE;
		break;
	default:
		*status = 999;
		/*Bad news if this is ever reached! */
		break;
	}
}


/* If there's room for another shape, add it to the card. */
void AddShape(int x, int y, int *status, int *object_count2, 
			   int object_type[], int object_num[], int object_color[], 
			   int object_x[], int object_y[], int *status2)
{
	*status = STATUS_SELECTED;
	object_type[*object_count2] = OBJECT_SHAPE;
	if(*status2 == STATUS_ADD_SHAPE)
	{
		object_num[*object_count2] = SHAPE_HEART;
		object_color[*object_count2] = RED;
	}
	object_x[*object_count2] = x;
	object_y[*object_count2] = y;
	*status2 = STATUS_KEEP_SHAPE;
}

/* Add a message */
void AddMessage(int x, int y, int *status, int *object_count2, 
			   int object_type[], int object_num[], int object_color[], 
			   int object_x[], int object_y[], int *status2)
{
	*status = STATUS_SELECTED;
	object_type[*object_count2] = OBJECT_MESSAGE;
	if(*status2 == STATUS_ADD_MESSAGE)
	{
		object_num[*object_count2] = MESSAGE1;
		object_color[*object_count2] = RED;
	}
	object_x[*object_count2] = x;
	object_y[*object_count2] = y;
	*status2 = STATUS_KEEP_MESSAGE;
}

